# -*- coding: utf-8 -*-
from setuphelpers import *
import copy


def install():
    pass


def audit():
    # AppxPackage
    appx_package_dict = run_powershell("Get-AppxPackage -AllUsers")
    by_user_dict = {}
    by_app_dict = {a["Name"]: a for a in appx_package_dict}
    for entry in appx_package_dict:
        for user_account in entry["PackageUserInformation"]:
            sid = user_account.split(" ")[0]
            if not sid in by_user_dict:
                by_user_dict[sid] = {}
            entrycopy = copy.deepcopy(entry)
            del entrycopy["PackageUserInformation"]
            by_user_dict[sid][entry["Name"]] = entrycopy
    appx_package_dict_entry = {"sort_by_sid": by_user_dict, "sort_by_name": by_app_dict}

    # AppxProvisionedPackage
    appx_provisionned_package_dict = run_powershell("Get-AppxProvisionedPackage -Online")
    appx_provisionned_package_dict_entry = {a["DisplayName"]: a for a in appx_provisionned_package_dict}

    # WAPT.write_audit_data_if_changed("audit-appx", "sort_by_sid", by_user_dict)
    # WAPT.write_audit_data_if_changed("audit-appx", "sort_by_name", by_app_dict)
    WAPT.write_audit_data_if_changed("audit-appx", "AppxPackage", appx_package_dict_entry)
    WAPT.write_audit_data_if_changed("audit-appx", "AppxProvisionedPackage", appx_provisionned_package_dict_entry)

    return "OK"
